Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.udo.cs.miningmart.m4.core
Class Column

    java.lang.Object
      edu.udo.cs.miningmart.m4.core.M4Object
          edu.udo.cs.miningmart.m4.core.M4Data
              edu.udo.cs.miningmart.m4.core.Column

All Implemented Interfaces:
  Column, M4Data, M4Object, M4Table, XmlInfo, java.io.Serializable, java.lang.Comparable

    public class Column

extends M4Data
implements XmlInfo, Column

This class represents an M4 column.

Version:
  $Id: Column.java,v 1.17 2006/10/01 19:14:22 euler Exp $
Author:
  Martin Scholz
See Also:
  Serialized Form

Field Summary
`static java.lang.String` | `ATTRIB_COL_BA_BAID` DB level: BaseAttribute ID of the Column to BaseAttribute cross-table
`static java.lang.String` | `ATTRIB_COL_BA_COLID` DB level: Column ID attribute of the Column to BaseAttribute cross-table
`static java.lang.String` | `ATTRIB_COL_BA_TUPLE_ID` DB level: The primary key attribute of the Column to BaseAttribute cross-table
`static java.lang.String` | `ATTRIB_COLUMN_DATATYPE` DB level: name of the column's (relational) datatype ID attribute
`static java.lang.String` | `ATTRIB_COLUMN_ID` DB level: name of the column ID attribute
`static java.lang.String` | `ATTRIB_COLUMN_NAME` DB level: name of the column name attribute
`static java.lang.String` | `ATTRIB_COLUMN_SQL` DB level: name of the column's SQL definition attribute
`static java.lang.String` | `ATTRIB_COLUMNSET_ID` DB level: name of the column's columnset id reference attribute
`static java.lang.String` | `M4_TABLE_COL_BA` Name of the Column to BaseAttribute cross-table
`static java.lang.String` | `M4_TABLE_NAME` Name of the M4 table representing `Column`s
`static M4Info` | `m4Info` Cache for getM4Info()

Fields inherited from class edu.udo.cs.miningmart.m4.core.M4Data
`myDocumentation`

Fields inherited from class edu.udo.cs.miningmart.m4.core.M4Object
`myId, myName`

Fields inherited from interface edu.udo.cs.miningmart.m4.utils.XmlInfo
`M4_XML_VERSION, TAG_COLLECTION, TAG_DOUBLE, TAG_INTEGER, TAG_LONG, TAG_M4_ID, TAG_SHORT, TAG_STRING, TAG_XML_ID`

Fields inherited from interface edu.udo.cs.miningmart.m4.utils.M4Table
`NOT_NULL`

Constructor Summary
`Column(DB m4Db)`

Method Summary
`void` | `clearStatistics()` If data changes in the database, e.g. a DB Concept is edited, then this method allows to delete the deprecated statistics objects without running a garbage collection.
`Column` | `copyColToCS(Columnset cs)` Makes a copy of this `Column` that belongs to the given `Columnset`.
`protected void` | `deleteLocal()` This method is called after the generic delete and can be overridden to delete related objects stored in cross-tables etc.
`void` | `deleteSoon()` Overwrites the superclass method because the keys referring to this column must be deleted, too.
`java.lang.String` | `getAverageValue()`
`java.util.Collection` | `getBasicColStats()` Active getter for all basic statistics tuples pointing to this Columm.
`long` | `getColumnDataType()`
`java.lang.String` | `getColumnDataTypeName()`
`Columnset` | `getColumnset()`
`java.util.Collection` | `getDependentObjects()` This method is part of the XML-serialization and needs to be implemented by all `M4Data` sub-classes that need to be serialized.
`java.util.Collection` | `getDistributionStatistics()` Active getter for all distribution statistics tuples pointing to this Columm.
`java.util.Collection` | `getForeignKeyMembers()` Active getter for the `KeyMember`s referencing this object as their foreign key.
`java.lang.String` | `getIdAttributeName()`
`M4Info` | `getM4Info()`
`java.lang.String` | `getM4TableName()`
`java.lang.String` | `getMaxValue()`
`java.lang.String` | `getMedianValue()`
`java.lang.String` | `getMinValue()`
`java.lang.String` | `getModalValue()`
`int` | `getNumberOfMissingValues()`
`int` | `getNumberOfUniqueValues()`
`protected java.util.Collection` | `getObjectsInNamespace(java.lang.Class typeOfObjects)` This method returns the objects of the specified type that form a namespace in the scope of this M4Data object.
`java.util.Collection` | `getPrimaryKeyMembers()` Active getter for the `KeyMember`s referencing this object as their primary key.
`java.lang.String` | `getSQLDefinition()`
`java.lang.String` | `getSQLPlusLocation()`
`java.lang.String` | `getStandardDeviation()`
`BaseAttribute` | `getTheBaseAttribute()` Get this column's BaseAtttribute.
`java.lang.String` | `getVariance()`
`M4Info` | `getXmlInfo()`
`void` | `primitiveSetBaseAttribute(BaseAttribute ba)` Primitive setter, do not use.
`void` | `primitiveSetColumnset(Columnset cs)` Primitive setter, do not use.
`void` | `print()` Print the information about this column.
`protected void` | `readFromDbLocal()` Loads `this` object's `BaseAttribute` from a cross-table at loading time.
`java.lang.String` | `readOrComputeAverage()` Reads, or computes the average value of this column and returns it as a string.
`java.lang.String` | `readOrComputeMaximum()` Reads, or computes the maximum value of this column and returns it as a string.
`java.lang.String` | `readOrComputeMinimum()` Reads, or computes the minimum value of this column and returns it as a string.
`int` | `readOrComputeNumMissingValues()` Reads, or computes the number of missing values for this column and returns it as an int.
`java.lang.String` | `readOrComputeStdDev()` Reads, or computes the standard deviation of this column and returns the result as a string.
`int` | `readOrComputeUniqueValues()` Reads, or computes the number of unique values for this column and returns it as an int.
`protected void` | `removeAllM4References()` This method needs to be implemented by all `M4Data` objects.
`void` | `removeBaseAttribute()` Disassociates the BaseAttrbute from this colum.
`protected void` | `setAverageValue(java.lang.String avg)` Sets the average of values of this column.
`void` | `setBaseAttribute(BaseAttribute ba)` Set this column's BaseAttribute.
`void` | `setColumnDataType(long type)` Set the column data type for this column.
`void` | `setColumnDataTypeName(java.lang.String dtname)` Set the name of this column's column data type.
`void` | `setColumnset(Columnset cs)` Sets the ColumnSet for this column.
`void` | `setDistributionStatistics(java.util.Collection dStats)` Sets the distribution statistics collection at once to the specified collection.
`void` | `setMaxValue(double newMax)`
`protected void` | `setMaxValue(java.lang.String max)` Sets the maximal value.
`protected void` | `setMedianValue(java.lang.String med)` Sets the median value.
`void` | `setMinValue(double newMin)`
`protected void` | `setMinValue(java.lang.String min)` Sets the minimal value.
`protected void` | `setModalValue(java.lang.String mod)` Sets the modal value.
`void` | `setName(java.lang.String name)` Do not use spaces in Column names, because these names are also used at the DB level.
`void` | `setNumberOfMissingValues(int nmv)` Sets the number of missing values.
`protected void` | `setNumberOfUniqueValues(int nuv)` Sets the number of unique values.
`void` | `setSQLDefinition(java.lang.String sqlDefinition)` Set the sql definition of this column.
`protected void` | `setStandardDeviation(java.lang.String stddev)` Sets the standard deviation of values of this column.
`protected void` | `setVariance(java.lang.String var)` Sets the variance of values of this column.
`void` | `storeLocal()` This method stores the pseudo foreign key reference to this objects's `BaseAttribute`, which is still realized by a cross-table (BA_COLUMN_T).
`void` | `updateStatistics()` Calculates statistics for the specified column and stores it in the M4 tables COLSTATIST1/2.

Methods inherited from class edu.udo.cs.miningmart.m4.core.M4Data
`exportLocal, genericGetter, genericSetter, getDocumentation, getObjectsReferencingMe, getObjectsReferencingMe, getObjectTag, getUniqueName, getValidName, getValidName, getXmlIdTag, getXmlVersion, hasDeleteStatus, importLocal, isDirty, isWaitingForDelete, primitiveGetDocObject, primitiveSetDocObject, readFromDb, removeDocObject, removeFromDb, removeSetFromDb, setDirty, setDocumentation, setId, updateObjectsFromTable`

Methods inherited from class edu.udo.cs.miningmart.m4.core.M4Object
`compareTo, doPrint, doPrint, equals, executeBusinessSingleValueSqlRead, executeBusinessSingleValueSqlReadL, executeBusinessSqlRead, executeBusinessSqlWrite, executeM4SingleValueSqlRead, executeM4SingleValueSqlReadL, executeM4SqlRead, executeM4SqlWrite, getCasePrintObject, getId, getM4Db, getM4ObjectFromCache, getName, getNextM4SequenceValue, isNew, load, putM4ObjectToCache, replaceSpacesInName, setNotNew`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface edu.udo.cs.miningmart.m4.utils.XmlInfo
`doPrint, doPrint, exportLocal, genericGetter, genericSetter, getObjectTag, getXmlIdTag, getXmlVersion, importLocal`

Methods inherited from interface edu.udo.cs.miningmart.m4.M4Data
`getDocumentation, getValidName, isDirty, isWaitingForDelete, setDocumentation`

Methods inherited from interface edu.udo.cs.miningmart.m4.M4Object
`doPrint, doPrint, equals, executeBusinessSingleValueSqlRead, executeBusinessSingleValueSqlReadL, executeBusinessSqlRead, executeBusinessSqlWrite, executeM4SingleValueSqlRead, executeM4SingleValueSqlReadL, executeM4SqlRead, executeM4SqlWrite, getCasePrintObject, getId, getM4Db, getM4ObjectFromCache, getName, getNextM4SequenceValue, isNew, load, putM4ObjectToCache, replaceSpacesInName, setId, setNotNew`

Field Detail

### M4_TABLE_NAME

    public static final java.lang.String M4_TABLE_NAME

  Name of the M4 table representing `Column`s

  See Also:
    Constant Field Values

### ATTRIB_COLUMN_ID

    public static final java.lang.String ATTRIB_COLUMN_ID

  DB level: name of the column ID attribute

  See Also:
    Constant Field Values

### ATTRIB_COLUMN_NAME

    public static final java.lang.String ATTRIB_COLUMN_NAME

  DB level: name of the column name attribute

  See Also:
    Constant Field Values

### ATTRIB_COLUMNSET_ID

    public static final java.lang.String ATTRIB_COLUMNSET_ID

  DB level: name of the column's columnset id reference attribute

  See Also:
    Constant Field Values

### ATTRIB_COLUMN_DATATYPE

    public static final java.lang.String ATTRIB_COLUMN_DATATYPE

  DB level: name of the column's (relational) datatype ID attribute

  See Also:
    Constant Field Values

### ATTRIB_COLUMN_SQL

    public static final java.lang.String ATTRIB_COLUMN_SQL

  DB level: name of the column's SQL definition attribute

  See Also:
    Constant Field Values

### M4_TABLE_COL_BA

    public static final java.lang.String M4_TABLE_COL_BA

  Name of the Column to BaseAttribute cross-table

  See Also:
    Constant Field Values

### ATTRIB_COL_BA_TUPLE_ID

    public static final java.lang.String ATTRIB_COL_BA_TUPLE_ID

  DB level: The primary key attribute of the Column to BaseAttribute cross-table

  See Also:
    Constant Field Values

### ATTRIB_COL_BA_COLID

    public static final java.lang.String ATTRIB_COL_BA_COLID

  DB level: Column ID attribute of the Column to BaseAttribute cross-table

  See Also:
    Constant Field Values

### ATTRIB_COL_BA_BAID

    public static final java.lang.String ATTRIB_COL_BA_BAID

  DB level: BaseAttribute ID of the Column to BaseAttribute cross-table

  See Also:
    Constant Field Values

### m4Info

    public static M4Info m4Info

  Cache for getM4Info()

Constructor Detail

### Column

    public Column(DB m4Db)

See Also:
  `edu.udo.cs.miningmart.m4.core.M4Data#Constructor`

Method Detail

### getM4TableName

    public java.lang.String getM4TableName()

  Specified by:
    `getM4TableName` in interface `M4Table`
  See Also:
    `M4Table.getM4TableName()`

### getIdAttributeName

    public java.lang.String getIdAttributeName()

  Specified by:
    `getIdAttributeName` in interface `M4Table`
  See Also:
    `M4Table.getIdAttributeName()`

### getM4Info

    public M4Info getM4Info()

  Specified by:
    `getM4Info` in interface `M4Table`
  See Also:
    `M4Table.getM4Info()`

### getXmlInfo

    public M4Info getXmlInfo()

  Specified by:
    `getXmlInfo` in interface `XmlInfo`
  Returns:
    a `M4Info` object with the information of all XML fields of `this` object.
  See Also:
    `XmlInfo.getXmlInfo()`

### print

    public void print()

  Print the information about this column.

  Specified by:
    `print` in interface `M4Object`
  Specified by:
    `print` in class `M4Object`

### setName

    public void setName(java.lang.String name)

  Do not use spaces in Column names, because these names are also used at the DB level.

  Specified by:
    `setName` in interface `M4Object`
  Overrides:
    `setName` in class `M4Data`
  Parameters:
    `name` - the new name to be set
  See Also:
    `M4Object.setName(String)`

### getObjectsInNamespace

    protected java.util.Collection getObjectsInNamespace(java.lang.Class typeOfObjects)
                                                  throws M4Exception

  Description copied from class: `M4Data`
  This method returns the objects of the specified type that form a namespace in the scope of this M4Data object. For example, a Concept's namespace for the type BaseAttribute is the Collection of all BaseAttributes for this Concept. Many M4Data objects never have a namespace, they return `null`. If a namespace could exist but doesn't, an empty Collection is returned.

  Specified by:
    `getObjectsInNamespace` in class `M4Data`
  Parameters:
    `typeOfObjects` - the type of objects that form the namespace
  Returns:
    a Collection of objects of type `typeOfObjects`, or `null`.
  Throws:
    `M4Exception`
  See Also:
    `M4Data.getObjectsInNamespace(Class)`

### copyColToCS

    public Column copyColToCS(Columnset cs)
                       throws M4Exception

  Makes a copy of this `Column` that belongs to the given `Columnset`.

  Specified by:
    `copyColToCS` in interface `Column`
  Parameters:
    `cs` - A Columnset
  Returns:
    A copy of this Column that points to the given Columnset
  Throws:
    `M4Exception`

### setBaseAttribute

    public void setBaseAttribute(BaseAttribute ba)
                          throws M4Exception

  Set this column's BaseAttribute.

  Specified by:
    `setBaseAttribute` in interface `Column`
  Parameters:
    `ba` - The new BaseAttribute.
  Throws:
    `M4Exception`

### getTheBaseAttribute

    public BaseAttribute getTheBaseAttribute()
                                      throws M4Exception

  Get this column's BaseAtttribute.

  Specified by:
    `getTheBaseAttribute` in interface `Column`
  Returns:
    this column's BaseAttribute.
  Throws:
    `M4Exception`

### setSQLDefinition

    public void setSQLDefinition(java.lang.String sqlDefinition)

  Set the sql definition of this column.

  Specified by:
    `setSQLDefinition` in interface `Column`
  Parameters:
    `sqlDefinition` - the new definition

### getSQLDefinition

    public java.lang.String getSQLDefinition()

  Specified by:
    `getSQLDefinition` in interface `Column`
  Returns:
    this column's sql definition as a String

### getSQLPlusLocation

    public java.lang.String getSQLPlusLocation()

  Specified by:
    `getSQLPlusLocation` in interface `Column`
  Returns:
    this column's sql definition together with schema name and table name (`schema.table.sql`)

### setColumnDataType

    public void setColumnDataType(long type)

  Set the column data type for this column.

  Specified by:
    `setColumnDataType` in interface `Column`
  Parameters:
    `type` - the new column data type

### getColumnDataType

    public long getColumnDataType()

  Specified by:
    `getColumnDataType` in interface `Column`
  Returns:
    this column's column data type

### setColumnDataTypeName

    public void setColumnDataTypeName(java.lang.String dtname)
                               throws M4Exception

  Set the name of this column's column data type.

  Specified by:
    `setColumnDataTypeName` in interface `Column`
  Parameters:
    `dtname` - the new name
  Throws:
    `M4Exception`

### getColumnDataTypeName

    public java.lang.String getColumnDataTypeName()
                                           throws M4Exception

  Specified by:
    `getColumnDataTypeName` in interface `Column`
  Returns:
    the name of this column's column data type.
  Throws:
    `M4Exception`

### getPrimaryKeyMembers

    public java.util.Collection getPrimaryKeyMembers()
                                              throws M4Exception

  Active getter for the `KeyMember`s referencing this object as their primary key.

  Specified by:
    `getPrimaryKeyMembers` in interface `Column`
  Returns:
    a `Collection` of `KeyMember` objects
  Throws:
    `M4Exception`

### getForeignKeyMembers

    public java.util.Collection getForeignKeyMembers()
                                              throws M4Exception

  Active getter for the `KeyMember`s referencing this object as their foreign key.

  Specified by:
    `getForeignKeyMembers` in interface `Column`
  Returns:
    a `Collection` of `KeyMember` objects
  Throws:
    `M4Exception`

### getBasicColStats

    public java.util.Collection getBasicColStats()
                                          throws M4Exception

  Active getter for all basic statistics tuples pointing to this Columm.

  Specified by:
    `getBasicColStats` in interface `Column`
  Returns:
    `Collection` of `ColumnStatistics1` objects
  Throws:
    `M4Exception`

### getDistributionStatistics

    public java.util.Collection getDistributionStatistics()
                                                   throws M4Exception

  Active getter for all distribution statistics tuples pointing to this Columm.

  Specified by:
    `getDistributionStatistics` in interface `Column`
  Returns:
    `Collection` of `ColumnStatistics2` objects
  Throws:
    `M4Exception`

### setDistributionStatistics

    public void setDistributionStatistics(java.util.Collection dStats)
                                   throws M4Exception

  Sets the distribution statistics collection at once to the specified collection.

  Specified by:
    `setDistributionStatistics` in interface `Column`
  Parameters:
    `dStats` - a `Collection` of `ColumnStatistics2` objects.
  Throws:
    `M4Exception`

### getNumberOfUniqueValues

    public int getNumberOfUniqueValues()
                                throws M4Exception

  Specified by:
    `getNumberOfUniqueValues` in interface `Column`
  Returns:
    If known, the number of unique values of this column.
  Throws:
    `M4Exception`

### getNumberOfMissingValues

    public int getNumberOfMissingValues()
                                 throws M4Exception

  Specified by:
    `getNumberOfMissingValues` in interface `Column`
  Returns:
    If known, the number of missing values of this column.
  Throws:
    `M4Exception`

### getMinValue

    public java.lang.String getMinValue()
                                 throws M4Exception

  Specified by:
    `getMinValue` in interface `Column`
  Returns:
    If known, the smallest value in this column.
  Throws:
    `M4Exception`

### getMaxValue

    public java.lang.String getMaxValue()
                                 throws M4Exception

  Specified by:
    `getMaxValue` in interface `Column`
  Returns:
    If known, the biggest value in this column.
  Throws:
    `M4Exception`

### getMedianValue

    public java.lang.String getMedianValue()
                                    throws M4Exception

  Specified by:
    `getMedianValue` in interface `Column`
  Returns:
    If known, the median value in this column.
  Throws:
    `M4Exception`

### getModalValue

    public java.lang.String getModalValue()
                                   throws M4Exception

  Specified by:
    `getModalValue` in interface `Column`
  Returns:
    If known, the modal value in this column.
  Throws:
    `M4Exception`

### getAverageValue

    public java.lang.String getAverageValue()
                                     throws M4Exception

  Specified by:
    `getAverageValue` in interface `Column`
  Returns:
    If known, the average of the values in this column.
  Throws:
    `M4Exception`

### getStandardDeviation

    public java.lang.String getStandardDeviation()
                                          throws M4Exception

  Specified by:
    `getStandardDeviation` in interface `Column`
  Returns:
    If known, the standard deviation of the values in this column.
  Throws:
    `M4Exception`

### getVariance

    public java.lang.String getVariance()
                                 throws M4Exception

  Specified by:
    `getVariance` in interface `Column`
  Returns:
    If known, the variance of the values in this column.
  Throws:
    `M4Exception`

### setNumberOfUniqueValues

    protected void setNumberOfUniqueValues(int nuv)
                                    throws M4Exception

  Sets the number of unique values.

  Parameters:
    `nuv` - the new number
  Throws:
    `M4Exception`

### setNumberOfMissingValues

    public void setNumberOfMissingValues(int nmv)
                                  throws M4Exception

  Sets the number of missing values.

  Specified by:
    `setNumberOfMissingValues` in interface `Column`
  Parameters:
    `nmv` - the new number
  Throws:
    `M4Exception`

### setMinValue

    protected void setMinValue(java.lang.String min)
                        throws M4Exception

  Sets the minimal value.

  Parameters:
    `min` - the new minimum
  Throws:
    `M4Exception`

### setMaxValue

    public void setMaxValue(double newMax)
                     throws M4Exception

  Specified by:
    `setMaxValue` in interface `Column`
  Throws:
    `M4Exception`

### setMinValue

    public void setMinValue(double newMin)
                     throws M4Exception

  Specified by:
    `setMinValue` in interface `Column`
  Throws:
    `M4Exception`

### setMaxValue

    protected void setMaxValue(java.lang.String max)
                        throws M4Exception

  Sets the maximal value.

  Parameters:
    `max` - the new maximum
  Throws:
    `M4Exception`

### setMedianValue

    protected void setMedianValue(java.lang.String med)
                           throws M4Exception

  Sets the median value.

  Parameters:
    `med` - the new median
  Throws:
    `M4Exception`

### setModalValue

    protected void setModalValue(java.lang.String mod)
                          throws M4Exception

  Sets the modal value.

  Parameters:
    `mod` - the new modal
  Throws:
    `M4Exception`

### setAverageValue

    protected void setAverageValue(java.lang.String avg)
                            throws M4Exception

  Sets the average of values of this column.

  Parameters:
    `avg` - the new average
  Throws:
    `M4Exception`

### setStandardDeviation

    protected void setStandardDeviation(java.lang.String stddev)
                                 throws M4Exception

  Sets the standard deviation of values of this column.

  Parameters:
    `stddev` - the new standard deviation
  Throws:
    `M4Exception`

### setVariance

    protected void setVariance(java.lang.String var)
                        throws M4Exception

  Sets the variance of values of this column.

  Parameters:
    `var` - the new variance
  Throws:
    `M4Exception`

### getColumnset

    public Columnset getColumnset()

  Specified by:
    `getColumnset` in interface `Column`
  Returns:
    this column's ColumnSet.

### setColumnset

    public void setColumnset(Columnset cs)
                      throws M4Exception

  Sets the ColumnSet for this column.

  Specified by:
    `setColumnset` in interface `Column`
  Parameters:
    `cs` - The new ColumnSet
  Throws:
    `M4Exception`

### readOrComputeMinimum

    public java.lang.String readOrComputeMinimum()
                                          throws M4Exception

  Reads, or computes the minimum value of this column and returns it as a string.

  Specified by:
    `readOrComputeMinimum` in interface `Column`
  Returns:
    the minimum value in the column as a String
  Throws:
    `M4Exception`

### readOrComputeAverage

    public java.lang.String readOrComputeAverage()
                                          throws M4Exception

  Reads, or computes the average value of this column and returns it as a string.

  Specified by:
    `readOrComputeAverage` in interface `Column`
  Returns:
    the average value in the column as a String
  Throws:
    `M4Exception`

### readOrComputeStdDev

    public java.lang.String readOrComputeStdDev()
                                         throws M4Exception

  Reads, or computes the standard deviation of this column and returns the result as a string.

  Specified by:
    `readOrComputeStdDev` in interface `Column`
  Returns:
    the average value in the column as a String
  Throws:
    `M4Exception`

### readOrComputeMaximum

    public java.lang.String readOrComputeMaximum()
                                          throws M4Exception

  Reads, or computes the maximum value of this column and returns it as a string.

  Specified by:
    `readOrComputeMaximum` in interface `Column`
  Returns:
    the maximum value in the column as a String
  Throws:
    `M4Exception`

### readOrComputeNumMissingValues

    public int readOrComputeNumMissingValues()
                                      throws M4Exception

  Reads, or computes the number of missing values for this column and returns it as an int.

  Specified by:
    `readOrComputeNumMissingValues` in interface `Column`
  Returns:
    the maximum value in the column as an int
  Throws:
    `M4Exception`

### readOrComputeUniqueValues

    public int readOrComputeUniqueValues()
                                  throws M4Exception

  Reads, or computes the number of unique values for this column and returns it as an int.

  Specified by:
    `readOrComputeUniqueValues` in interface `Column`
  Returns:
    the maximum value in the column as a String
  Throws:
    `M4Exception`

### clearStatistics

    public void clearStatistics()
                         throws M4Exception

  If data changes in the database, e.g. a DB Concept is edited, then this method allows to delete the deprecated statistics objects without running a garbage collection.

  Specified by:
    `clearStatistics` in interface `Column`
  Throws:
    `M4Exception`

### updateStatistics

    public void updateStatistics()
                          throws M4Exception

  Calculates statistics for the specified column and stores it in the M4 tables COLSTATIST1/2. Values that are already present are not overwritten, because it is expected that the garbage collection removes any deprecated values.

  Specified by:
    `updateStatistics` in interface `Column`
  Parameters:
    `conceptualDataType` - The conceptual datatype of the column.
  Throws:
    `M4Exception`

### primitiveSetBaseAttribute

    public void primitiveSetBaseAttribute(BaseAttribute ba)

  Primitive setter, do not use.

  Parameters:
    `ba` - the `BaseAttribute` to be set

### primitiveSetColumnset

    public void primitiveSetColumnset(Columnset cs)

  Primitive setter, do not use.

  Parameters:
    `cs` - the `Columnset` to be set

### readFromDbLocal

    protected void readFromDbLocal()
                            throws M4Exception

  Loads `this` object's `BaseAttribute` from a cross-table at loading time.

  Overrides:
    `readFromDbLocal` in class `M4Data`
  Throws:
    `M4Exception`

### storeLocal

    public void storeLocal()
                    throws M4Exception

  This method stores the pseudo foreign key reference to this objects's `BaseAttribute`, which is still realized by a cross-table (BA_COLUMN_T).

  Specified by:
    `storeLocal` in interface `Column`
  Overrides:
    `storeLocal` in class `M4Data`
  Throws:
    `M4Exception`

### deleteLocal

    protected void deleteLocal()
                        throws M4Exception

  Description copied from class: `M4Data`
  This method is called after the generic delete and can be overridden to delete related objects stored in cross-tables etc.

  Overrides:
    `deleteLocal` in class `M4Data`
  Throws:
    `M4Exception`

### deleteSoon

    public void deleteSoon()
                    throws M4Exception

  Overwrites the superclass method because the keys referring to this column must be deleted, too.

  Specified by:
    `deleteSoon` in interface `M4Data`
  Overrides:
    `deleteSoon` in class `M4Data`
  Throws:
    `M4Exception`

### removeAllM4References

    protected void removeAllM4References()
                                  throws M4Exception

  Description copied from class: `M4Data`
  This method needs to be implemented by all `M4Data` objects. It has to remove all references to other `M4Object`s.

  Specified by:
    `removeAllM4References` in class `M4Data`
  Throws:
    `M4Exception`
  See Also:
    `M4Data.removeAllM4References()`

### getDependentObjects

    public java.util.Collection getDependentObjects()
                                             throws M4Exception

  Description copied from class: `M4Data`
  This method is part of the XML-serialization and needs to be implemented by all `M4Data` sub-classes that need to be serialized.

  Specified by:
    `getDependentObjects` in interface `XmlInfo`
  Overrides:
    `getDependentObjects` in class `M4Data`
  Returns:
    a `Collection` of all `M4Data` Java objects holding a foreign key reference to `this` object. This method must never return `null`.
  Throws:
    `M4Exception`
  See Also:
    `M4Data.getDependentObjects()`

### removeBaseAttribute

    public void removeBaseAttribute()
                             throws M4Exception

  Description copied from interface: `Column`
  Disassociates the BaseAttrbute from this colum. Does not delete the BA involved.

  Specified by:
    `removeBaseAttribute` in interface `Column`
  Throws:
    `M4Exception`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005